// The text field in the view that we actually want to test
var textField = Ti.UI.createTextField({
  borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
  color: '#336699',
  top: 40, width: 400
});

// Button to remove text field view
var button = Ti.UI.createButton({ title: 'Remove' });

// Blurs any focused text view, and then switches view to the second one.
// XXX: this is where the bug occurs; when a blur is called right after
// the win.remove of the text view, a race condition occurs where the remove
// actually occurs before the blur call.
// 
// Underlying this is blur uses TiMessenger#postOnMain, which uses Message#sendToTarget
// underneath, whereas TiUIView#remove uses TiMessegner#sendBlockingMessage,
// which if another sendBlockingMessage was already running, will be ran before
// that sendBlockingMessage finishes, and more notably before the blur message is
// processed.
button.addEventListener('click', function(){
	textField.blur();
	view.remove(textField);
});

var view = Ti.UI.createView();

// Adding all the components into the first view
view.add(textField);
view.add(button);

// Creating the heavyweight window and setting the view
var win = Ti.UI.createWindow({
	backgroundColor:'#ffffff',
	navBarHidden:true,
	exitOnClose:true
});
win.add(view);
win.open();
